import static java.lang.System.out;

public class OneSubclass extends OneSuperclass {

  // public int doIt(String str, Integer[] data)    // (1) Compile time error
  public int doIt(String str, Integer... data)   // Overridden
             throws java.io.FileNotFoundException {
    String signature = "(String, Integer[])";
    out.println("Overridden: " + str + " => " + signature);
    return 0;
  }

  public void doIt(String str, Object... data) { // Overloading
    String signature = "(String, Object[])";
    out.println(str + " => " + signature);
  }

  public static void main(String[] args) throws Exception {
    OneSubclass ref = new OneSubclass();
    ref.doIt("(String)");
    ref.doIt("(String, int)",           10);
    ref.doIt("(String, Integer)",       new Integer(10));
    ref.doIt("(String, int, byte)",     10, (byte)20);
    ref.doIt("(String, int, int)",      10,  20);
    ref.doIt("(String, int, long)",     10,  20L);
    ref.doIt("(String, int, int, int)", 10,  20,  30);
    ref.doIt("(String, int, double)",   10,  20.0);
    ref.doIt("(String, int, String)",   10,  "what?");
    ref.doIt("(String, boolean)",       false);
  }
}