import static java.lang.System.out;

class VarargsOverloading {

  public void operation(String str) {
    String signature = "(String)";
    out.println(str + " => " + signature);
  }

  public void operation(String str, int m) {
    String signature = "(String, int)";
    out.println(str + " => " + signature);
  }

  public void operation(String str, int m, int n) {
    String signature = "(String, int, int)";
    out.println(str + " => " + signature);
  }

  public void operation(String str, Integer... data) {
    String signature = "(String, Integer[])";
    out.println(str + " => " + signature);
  }

  public void operation(String str, Number... data) {
    String signature = "(String, Number[])";
    out.println(str + " => " + signature);
  }

  public void operation(String str, Object... data) {
    String signature = "(String, Object[])";
    out.println(str + " => " + signature);
  }

  public static void main(String[] args) {
    VarargsOverloading ref = new VarargsOverloading();
    ref.operation("(String)");
    ref.operation("(String, int)",           10);
    ref.operation("(String, Integer)",       new Integer(10));
    ref.operation("(String, int, byte)",     10, (byte)20);
    ref.operation("(String, int, int)",      10,  20);
    ref.operation("(String, int, long)",     10,  20L);
    ref.operation("(String, int, int, int)", 10,  20,  30);
    ref.operation("(String, int, double)",   10,  20.0);
    ref.operation("(String, int, String)",   10,  "what?");
    ref.operation("(String, boolean)",       false);
  }
}